
#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define DIM 1000000
int x[DIM], y[DIM], z[DIM];

// struttura che definisce i parametri della funzione sum
struct PAR
{
 int first_index;
 int last_index;
};

// funzione che implementa il codice dei thread
unsigned long WINAPI sum(void* arg)
{
 int i;

 struct PAR *tmp = (struct PAR*)(arg);
 struct PAR par = *tmp;

 for (i=par.first_index; i<=par.last_index; i++)
    z[i] = x[i] + y[i];
 
 ExitThread(0);
}


void main(void)
{
 int i;
 struct PAR par_1, par_2, par_3, par_4;
 HANDLE thread[4];

 // generazione casuale degli elementi dei vettori X e Y
 for (i=0; i<DIM; i++)
    {
	 x[i] = rand()%10000;
	 y[i] = rand()%10000;
    }

 // estremi della sezione di vettore assegnata al primo thread
 par_1.first_index = 0;
 par_1.last_index = DIM/4-1;

 // estremi della sezione di vettore assegnata al secondo thread
 par_2.first_index = DIM/4;
 par_2.last_index = DIM/2-1;

 // estremi della sezione di vettore assegnata al terzo thread
 par_3.first_index = DIM/2;
 par_3.last_index = DIM*3/4-1;

 // estremi della sezione di vettore assegnata al quarto thread
 par_4.first_index = DIM*3/4;
 par_4.last_index = DIM-1;

 // creazione dei thread e attesa della loro terminazione
 thread[0] = CreateThread(NULL,4096,&sum,&par_1,0,NULL);
 thread[1] = CreateThread(NULL,4096,&sum,&par_2,0,NULL);
 thread[2] = CreateThread(NULL,4096,&sum,&par_3,0,NULL);
 thread[3] = CreateThread(NULL,4096,&sum,&par_4,0,NULL);

 WaitForMultipleObjects(4,thread,1,INFINITE);
 
 printf("Somma completata\r\n");

 // verifica correttezza somma
 for (i=0; i<DIM; i++)
    if (z[i] != x[i] + y[i])
      printf("Risultato errato alla posizione %i\r\n", i);
}
